    1    0000                     	|**     runtime startoff
    2    0000                     	|
    3    0000                     	|	calls main
    4    0000                     	|	call exit
    5    0000                     	
    6    0000                     	
    7    0000                     	
    8    0000                     	|**     Calling the Operating system
    9    0000                     	|
   10    0000                     	|       Since each 8086 system tends to be different, all operating
   11    0000                     	|       system features are accessed by calling certain 'magic offsets'
   12    0000                     	|       in the low code-space of the user program.  There are currently
   13    0000                     	|       three of these entry points; each is called by a long-call
   14    0000                     	|       instruction.
   15    0000                     	|
   16    0000                     	|       These three magic entry points are defined symbolicly here,
   17    0000                     	|       for convenient use by library routines.  However, the code which
   18    0000                     	|       impliments them is stuffed into low code space by the kernal
   19    0000                     	|       at 'exec' time.  Thus, the offsets of these entry points must
   20    0000                     	|       not be changed; as they are specified in routine ???? in the
   21    0000                     	|       kernal.
   22    0000                     	
   23    0000                     	
   24    0000                     	.globl	_exit, _environ, __syscal
   25    0000                     	.globl	start
   26    0000                     	.globl	_main
   27    0000                     	
   28    0000                     		.comm   _environ,2.
   29    0000                     	
   30    0000                     	exit = 1.
   31    0000                     	
   32    0000                     	start:                          |******   Start executing here
   33    0000                     	
   34    0000                     	|       These first 128 bytes will be set by the kernel when the
   35    0000                     	|       module is first executed.  The kernel assumes that the first
   36    0000                     	|       128 bytes of code space are available to it.  User code
   37    0000                     	|       must do long calls into one of 8 magic offsets in this
   38    0000                     	|       128-byte area:
   39    0000                     	
   40    0000   eb 00             		j       start0
   41    0002                     	__syscal:
   42    0002   eb fe             		j       .               | system call           +2
   43    0004   eb fe             		j       .               | stack growth          +4
   44    0006   eb fe             		j       .               | stack adjust          +6
   45    0008   eb fe             		j       .               | reserved              +8
   46    000a   eb fe             		j       .               | reserved              +10
   47    000c   eb fe             		j       .               | reserved              +12
   48    000e   eb fe             		j       .               | reserved              +14
   49    0010   eb fe             		j       .               | reserved              +16
   50    0012                     	
   51    0012                     	
   52    0080                     		.=start+128             | kernal loads first 128 bytes
   53    0080                     	
   54    0080                     	
   55    0080   8b dc             	start0: mov     bx,sp           | bx->ac,avs,envs
   56    0082   83 ec 04          		sub     sp,*4           | space for real arguments
   57    0085   83 c3 02          		add     bx,*2
   58    0088   53                		push    bx              | main (argv,
   59    0089   ff 77 fe          		push    *-2(bx)         | main (argc, argv
   60    008c                     	s1:
   61    008c   83 c3 02          		add     bx,*2           | next argv
   62    008f   f7 07 ff ff       		test    (bx),#/ffff     | look at pointer
   63    0093   75 f7             		jnz     s1              | loop until zero argv
   64    0095                     	
   65    0095   83 c3 02          		add     bx,*2           | first env
   66    0098   8b f4             		mov     si,sp
   67    009a   89 5c 04          		mov     *4(si),bx       | main (argc, argv, envv)
   68    009d   89 1e 00 00       		mov     _environ,bx     | place for people to look for them
   69    00a1                     	
   70    00a1   8c c8             		mov     ax,cs           | temporary until new linker, see
   71    00a3   a3 00 00          		mov     Isgadr+2,ax     |       'Isgadr'...
   72    00a6   a3 00 00          		mov     Iscadr+2,ax
   73    00a9                     	
   74    00a9   9a 00 00 00 00    		calli   _main
   75    00ae   83 c4 06          		add     sp,*6
   76    00b1   50                		push    ax              | pass return value to exit
   77    00b2   9a 00 00 00 00    	s2:     calli   _exit           | call portable exit
   78    00b7   eb f9             		j       s2              | _exit never returns{
   79    00b9                     	
   80    0000                     		.data
   81    0000   00 00             		.word   0       | loc 0 for I/D; null ptr points here.
   82    0002                     	
   83    0002                     	
   84    0002                     	|       Until we're using the new loader, its a pain generating segmented
   85    0002                     	|       addresses, and the library routines will call the Ios_?? entrys
   86    0002                     	|       indirectly through these addresses.  The segment values are filled
   87    0002                     	|       in when crt0 gets control
   88    0002                     	
   89    0002                     		.globl  Isgadr,Iscadr
   90    0002                     	
   91    0002   04 00             	Isgadr: .word   4               | stack growth
   92    0004   00 00             		.word   0
   93    0006   02 00             	Iscadr: .word   2               | system call
   94    0008   00 00             		.word   0
   95    000a                     	
   96    000a                     	
   97    000a                     	| C library -- signal
   98    000a                     	|
   99    000a                     	| signal(n, 0);		/* default action on signal(n) */
  100    000a                     	| signal(n, 1);		/* ignore signal(n)	M000 */
  101    000a                     	| signal(n, label);	/* call label(n) on signal(n) */
  102    000a                     	|
  103    000a                     	| returns old label, only one level.
  104    000a                     	|
  105    000a                     	|	arw	 9 Jan 1982	M000
  106    000a                     	|		- Modified to make the ignore signal argument as
  107    000a                     	|		  being exactly one.
  108    000a                     	|	arw	29 Sep 1982	M001
  109    000a                     	|		- Mods. to middle model version to correct bugs.
  110    000a                     	
  111    000a                     		.globl	_signal
  112    000a                     		.comm	_errno,2
  113    000a                     		.sigs = 48.
  114    000a                     	
  115    00b9                     		.text
  116    00b9                     	_signal:
  117    00b9   8b dc             		mov     bx,sp
  118    00bb   8b 4f 08          		mov     cx,*8(bx)       | (cx) = vector base
  119    00be   8b 57 06          		mov	dx,*6(bx)	| (dx) = vector offset
  120    00c1   8b 5f 04          		mov     bx,*4(bx)       | (bx) = signal number
  121    00c4   83 fb 10          		cmp     bx,*16.         | max signal
  122    00c7   77 00             		ja      sig2            | toobig
  123    00c9   8b c3             		mov     ax,bx           | (ax) = signal #, PRESERVE until syscal
  124    00cb   03 db             		add     bx,bx           | (bx) = 2*sig
  125    00cd   03 db             		add	bx,bx		| (bx) = 4*sig
  126    00cf   ff b7 00 00       		push	2+sigtab(bx)	| save old base value for return
  127    00d3   ff b7 00 00       		push    sigtab(bx)      | save old offset value for return
  128    00d7   89 8f 00 00       		mov	2+sigtab(bx),cx	| store users routine base addr in table
  129    00db   89 97 00 00       		mov     sigtab(bx),dx   | store users routine offset addr in table
  130    00df   23 d2             		and     dx,dx           | zero argument offset
  131    00e1   75 00             		jnz     sig4            | if zero offset, try for zero or one base
  132    00e3                     	
  133    00e3   23 c9             		and     cx,cx           | zero argument ?
  134    00e5   75 00             		jnz     sig1            | if zero then just give zero to kernel
  135    00e7                     	
  136    00e7   83 f9 01          		cmp	cx,*1           | special ignore argument?		* M000 *
  137    00ea   74 00             		jz	sig1            | if one then just give one to kernel	* M000 *
  138    00ec                     	
  139    00ec                     	sig4:
  140    00ec                     		.textref
  141    00ec   8d 8f 00 00       		lea     cx,sigvec(bx)   | tell os the addr of our routine
  142    00f0                     					| NOTE: segment base not given
  143    00f0                     					|	code must be in first relative segment
  144    00f0                     	
  145    00f0                     	|       (ax) = signal number
  146    00f0                     	|       ((sp)) = old signal value
  147    00f0                     	
  148    00f0   93                	sig1:   xchg    ax,bx           | (bx) = signal number
  149    00f1   b8 30 00          		mov     ax,*.sigs
  150    00f4   ff 1e 06 00       		calli   @Iscadr         | call XENIX
  151    00f8   58                		pop     ax              | (ax) = original table entry offset
  152    00f9   5a                		pop	dx		| (dx) = base for original table entry
  153    00fa   72 00             		jb      sig3            | if error
  154    00fc   a8 01             		testb   al,*1           | if ignored, just return
  155    00fe   75 00             		jnz     sig5
  156    0100   93                		xchg    ax,bx           | (ax) = previous table entry, not os value
  157    0101   eb 00             		j       sig5
  158    0103                     	
  159    0103                     	sig2:
  160    0103   b8 16 00          		mov     ax,*22.         | Invalid argument
  161    0106                     	sig3:
  162    0106   a3 00 00          		mov     _errno,ax
  163    0109   b8 ff ff          		mov     ax,*-1
  164    010c   ba ff ff          		mov	dx,*-1
  165    010f                     	sig5:
  166    010f   cb                		reti                    | return
  167    0110                     	
  168    0110                     	
  169    0110                     	|**	sigtrp - Handle signal traps
  170    0110                     	|
  171    0110                     	|	When a signal is intercepted, the system calls enters the
  172    0110                     	|	user-specified signal routine as if an interrupt had occured.
  173    0110                     	|	The signal routine must do an 'iret' back to the user task's
  174    0110                     	|	interrupted execution path.
  175    0110                     	|
  176    0110                     	|	Naturally, 'c' does not know how to generate this, so we
  177    0110                     	|	intersperse this 'thunk', which gets control from unix, passes
  178    0110                     	|	it to the user's routine, then properly restores control
  179    0110                     	|	to the interrupted execution path.
  180    0110                     	|
  181    0110                     	|       ENTRY   ((sp)+6) = return flags
  182    0110                     	|               ((sp)+4) = return cs
  183    0110                     	|               ((sp)+2) = return ip
  184    0110                     	|               ((sp))   = sigvec entry + 3
  185    0110                     	
  186    0110                     	sigtrp:
  187    0110                     	|       cli
  188    0110                     	|       push    ax
  189    0110                     	|       pop     ax
  190    0110                     	|       int     *3
  191    0110   55                		push    bp		| save all registers
  192    0111   8b ec             		mov     bp,sp
  193    0113   50                		push    ax
  194    0114   53                		push    bx
  195    0115   51                		push    cx
  196    0116   52                		push    dx
  197    0117   56                		push    si
  198    0118   57                		push    di
  199    0119   8b 46 02          		mov     ax,*2(bp)       | (ax) = return addr into sigvec
  200    011c   2d 00 00          		sub     ax,#sigvec+3    | (ax) = signal number * 4
  201    011f   8b d8             		mov	bx,ax		| (bx) = offset into sigtab	* M001 *
  202    0121   d1 e8             		shr     ax,*1
  203    0123   d1 e8             		shr     ax,*1           | /4
  204    0125   50                		push    ax              | pass signal # as param
  205    0126   ff 9f 00 00       		calli	@sigtab(bx)     | call 'c' routine		* M001 *
  206    012a   5f                		pop     di              | remove argument
  207    012b   5f                		pop     di
  208    012c   5e                		pop     si
  209    012d   5a                		pop     dx
  210    012e   59                		pop     cx
  211    012f   5b                		pop     bx
  212    0130   58                		pop     ax
  213    0131   5d                		pop     bp              | restore regs
  214    0132   83 c4 02          		add     sp,*2           | skip 'sigvec' return addr
  215    0135   cf                		iret
  216    0136                     	
  217    0136                     	
  218    0136                     	|**	sigvec - signal vector routine
  219    0136                     	|
  220    0136                     	|	unix is given an address in this table as the 'user routine'
  221    0136                     	|	to activate when a signal is received.  This 'routine' simply
  222    0136                     	|	encodes what the signal number was (via the return address)
  223    0136                     	|	and lets 'sigtrap' handle things.
  224    0136                     	
  225    0136                     	sigvec:
  226    0136   e8 d7 ff          		call    sigtrp			|signal 0
  227    0139   90                		nop				| each call is 4 bytes
  228    013a   e8 d3 ff          		call    sigtrp
  229    013d   90                		nop
  230    013e   e8 cf ff          		call    sigtrp
  231    0141   90                		nop
  232    0142   e8 cb ff          		call    sigtrp
  233    0145   90                		nop
  234    0146   e8 c7 ff          		call    sigtrp
  235    0149   90                		nop
  236    014a   e8 c3 ff          		call    sigtrp
  237    014d   90                		nop
  238    014e   e8 bf ff          		call    sigtrp
  239    0151   90                		nop
  240    0152   e8 bb ff          		call    sigtrp
  241    0155   90                		nop
  242    0156   e8 b7 ff          		call    sigtrp
  243    0159   90                		nop
  244    015a   e8 b3 ff          		call    sigtrp
  245    015d   90                		nop
  246    015e   e8 af ff          		call    sigtrp
  247    0161   90                		nop
  248    0162   e8 ab ff          		call    sigtrp
  249    0165   90                		nop
  250    0166   e8 a7 ff          		call    sigtrp
  251    0169   90                		nop
  252    016a   e8 a3 ff          		call    sigtrp
  253    016d   90                		nop
  254    016e   e8 9f ff          		call    sigtrp
  255    0171   90                		nop
  256    0172   e8 9b ff          		call    sigtrp
  257    0175   90                		nop
  258    0176   e8 97 ff          		call    sigtrp                 |through 16
  259    0179                     	
  260    000a                     		.data
  261    000a                     	
  262    000a                     	|*	User signal vectors
  263    000a                     	|*
  264    000a                     	|*	these cells contain the address of the user's signal routine
  265    000a                     	
  266    000a   00 00 00 00 00 00 	sigtab: .word   0,0,0,0,0,0,0,0,0
                00 00 00 00 00 00 
                00 00 00 00 00 00 
  267    001c   00 00 00 00 00 00 		.word	0,0,0,0,0,0,0,0,0
                00 00 00 00 00 00 
                00 00 00 00 00 00 
  268    002e   00 00 00 00 00 00 		.word	0,0,0,0,0,0,0,0,0
                00 00 00 00 00 00 
                00 00 00 00 00 00 
  269    0040   00 00 00 00 00 00 		.word	0,0,0,0,0,0,0,0,0
                00 00 00 00 00 00 
                00 00 00 00 00 00 
  270    0052                     	
  271    0179                     		.end
