|***    old = sbrk(increment);
|	
|	sbrk gets increment more core, and returns a pointer
|	       to the beginning of the new core area
|	


	.globl  _sbrk, _brk
	.comm	_errno,2
	.break = 17.
	ENOMEM = 12.

	.text
_sbrk:
	mov     bx,sp
	mov     bx,*4(bx)               | (bx) = increment
	mov     ax,nd                   | (ax) = current break
	and     bx,bx
	jz      sbrk0                   | no change, just report
	add     bx,ax
	jc	sbrk2
	mov     ax,*.break
	calli   @Iscadr         | call XENIX
	jb      sbrk1                   | error

	mov     ax,nd                   | return old limit
	mov     bx,sp
	mov     bx,*4(bx)
	add     bx,ax                   | increment limit
	mov     nd,bx
sbrk0:  reti

sbrk2:	mov	ax,#ENOMEM
sbrk1:  mov     _errno,ax
	mov     ax,#-1
	reti



|***    brk(value)
|
|	Set program break
|	returns 0 for ok, -1 for error.

_brk:
	mov     bx,sp
	mov     bx,*4(bx)       | arg 1
	push    bx              | save request
	mov     ax,*.break
	calli   @Iscadr         | call XENIX
	pop     ax              | (ax) = requested amount
	jnb     lab1            | no error
	mov     _errno,ax
	mov     ax,#-1
	reti
lab1:
	mov     nd,ax
	sub     ax,ax           | return 0
	reti

	.data
nd:
	.word   _end

	.end
