| C library -- fork
|
| pid = fork();
|
| pid == 0 in child process; pid == -1 means error return
| in child, parents id is in par_uid if needed

	.globl	_fork
	.comm   _errno,2
	.comm   _par_uid,2
	.fork = 2.

	.text
_fork:
	mov     ax,*.fork
	calli   @Iscadr         | call XENIX
	jb      lab1            | have error
	and     bx,bx
	jz      fork1           | is child

|       we are the parent process
|       (the system call must have 'taken'

	reti                    | exit with child number

lab1:   mov     _errno,ax       | error in call
	mov     ax,#-1
	reti

|       we are the child process
|       (or the system call was ignored due to inoportune interrupt

fork1:  mov     _par_uid,ax     | really am child process
	sub     ax,ax           | child gets a 0 return
	reti

	.end
