|**     strcmp - compare strings
|
|       strcmp (s1, s2)
|
|       returns   >0    s1 > s2
|                 0     s1 == s2
|                 <0    s1 < s2
| I000 ----- plb 25/7/83 cleared dir flag for string ops


	.globl  _strcmp

	.text

_strcmp:
	push    bp
	mov     bp,sp
	push    di
	push    si
	mov     si,*6.(bp)      | (si) = s1 pointer
	mov     di,*8.(bp)      | (di) = s2 pointer
	subb    ch,ch

	cld			| I000
scmp:   movb    cl,(si)
	cmpsb                   | compare the two
	jcxz    scmp2           | am at a null character
	je      scmp            | more to go

|       have a difference.
|       'c' set if s2 > s1

	sbb     ax,ax           | (ax) = -1 or 0
	incb    al              | (ax) = -256 or 1
	pop     si
	pop     di
	pop     bp
	reti

|       s1 has a null character.  Is equal or s1 < s2
|       'c' set iff s1<s2

scmp2:  sbb     ax,ax           | (ax) = 0 if equal, -1 of s1 < s2
	pop     si
	pop     di
	pop     bp
	reti
